#include "ca_mutex.hpp"
#include <stdlib.h>


CircularArray::CircularArray(int num_elem) : head(0), tail(0), num(0), 
                                             n_elem(num_elem),
                                             block_prod(0),
                                             block_cons(0)
{
        array = (int *)malloc(sizeof(int)*n_elem);
        pthread_mutex_init(&mutex, 0);
        pthread_cond_init(&empty, 0);
        pthread_cond_init(&full, 0);
        
}

bool CircularArray::insert(int elem)
{
        bool result = true;

        pthread_mutex_lock(&mutex);

        while (num == n_elem) 
                pthread_cond_wait(&full,&mutex);
        

        array[head] = elem;
        head = (head + 1) % n_elem;
        num++;

        pthread_cond_signal(&empty);

        pthread_mutex_unlock(&mutex);

        return result;
}

bool CircularArray::extract(int &elem)
{
        bool result = true;

        pthread_mutex_lock(&mutex);

        while (num == 0) 
                pthread_cond_wait(&empty,&mutex);

        elem = array[tail];
        tail = (tail + 1) % n_elem;
        num--;

        pthread_cond_signal(&full);

        pthread_mutex_unlock(&mutex);

        return result;
}
